////////////////////////////////////////////////////////////////////////////
//	t@C	F	dx_graphic.h
//	t@CTvF	dx_graphic W[wb_
//	쐬		F	M.Minami
////////////////////////////////////////////////////////////////////////////
#ifndef __DX_GRAPHIC_H_
#define __DX_GRAPHIC_H_

////////////////////////////////////////////////////////////////////////////
//						wb_t@C̃CN[h
////////////////////////////////////////////////////////////////////////////
#include <d3d8.h>								// DirectXGraphics wb_t@C
#include <d3dx8.h>								// D3DX wb_t@C

#define SCREEN_WIDTH	640
#define SCREEN_HEIGHT	480

////////////////////////////////////////////////////////////////////////////
//							}NA\̒`
////////////////////////////////////////////////////////////////////////////
// eNX`p ------------------------------------------------------------
// eNX`Ǘ\
typedef struct  {
	LPDIRECT3DTEXTURE8	Tex;					// eNX`obt@
	unsigned int		Width;					// eNX`
	unsigned int		Height;					// eNX`
} TEXTURE_DATA;

// eNX`obt@TCY
#define TEX_MAX		100

// XvCgp ------------------------------------------------------------
// uh[h
typedef enum {
	D3DBLEND_NORMAL,							// ʏAt@uh
	D3DBLEND_ADD								// ZAt@uh
} BLEND_MODE;

// _tH[}bg --------------------------------------------------------
// vZAWϊ_tH[}bg
typedef struct {
	float	x, y, z;							// Wϊςݒ_W
	float	rhw;								 
	DWORD	color;								// _Fiqfa`j
	DWORD	specular;							// XyLF
	float	tu0, tv0;							// eNX`W
} D3DTLVERTEX;

#define D3DFVF_TLVERTEX (D3DFVF_XYZRHW | D3DFVF_DIFFUSE |  D3DFVF_SPECULAR | D3DFVF_TEX1)

// WϊLACeBO_tH[}bg
typedef struct {
	float x, y, z;								// _W
	DWORD color;								// _Fiqfa`j
	DWORD specular;								// XyLF
	float tu0, tv0;								// eNX`W
} D3DLVERTEX;

#define D3DFVF_LVERTEX 		(D3DFVF_XYZ | D3DFVF_DIFFUSE |  D3DFVF_SPECULAR | D3DFVF_TEX1)

// WϊLACeBOL蒸_tH[}bg
typedef struct {
	float x,  y,  z;							// _W
	float nx, ny, nz;							// @xNg
	float tu0, tv0;								// eNX`W
} D3DVERTEX;

#define D3DFVF_VERTEX 		(D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1)

//	Cgp ---------------------------------------------------------------
typedef enum {
	D3DLIGHT_INIT,		// Cg
	D3DLIGHT_ON,		// Cgnm
	D3DLIGHT_OFF		// Cgnee
} D3DLIGHT_MODE;

////////////////////////////////////////////////////////////////////////////
//                     t@CԃC^[tF[X֐
////////////////////////////////////////////////////////////////////////////
// eNX`obt@擾
extern TEXTURE_DATA* GetTextureBuf(int idx);
// RcfoCX擾
extern LPDIRECT3DDEVICE8  GetD3DDevice(void);
extern LPDIRECT3DDEVICE8 g_pD3DDevice;

////////////////////////////////////////////////////////////////////////////
//                             OQƐ錾
////////////////////////////////////////////////////////////////////////////
// _CNgOtBbNX֐
extern BOOL GrpInit(HWND hwnd);
// _CNgOtBbNXJ֐
extern void GrpRelease(void);

// eNX`[h֐
extern BOOL GrpLoadTexture(int idx, char *bmp_name, D3DCOLOR rgba = 0);
// eNX`J֐
extern void GrpReleaseTexture(int idx);

// XvCg
extern void GrpSprInit(void);
// XvCgqfa`Zbg
extern void GrpSprRGBASet(BLEND_MODE mode, D3DCOLOR rgba);
// XvCg]pZbg
extern void GrpSprAngleSet(float angle, float cx, float cy);
// XvCgXP[Zbg
extern void GrpSprScaleSet(float sx, float sy);
// XvCg`
extern void GrpSprDraw(int x, int y, int idx, int u, int v, int w, int h);

// PF|S\
extern void GrpPolyDraw(float x, float y, float w, float h, D3DCOLOR rgba);
// eor\
extern void GrpFpsDisp(int x, int y);
// tHg\֐
extern void GrpFontDisp(char *str, int x, int y, D3DCOLOR color);

// ϊs̐ݒ
extern void GrpSetProjMat(float clip_near, float clip_far);
// Js̐ݒ
extern void GrpSetViewMat(D3DXVECTOR3 eye, D3DXVECTOR3 pos);
// r{[gp}gbNXݒ
extern void GrpSetBillBoardMat(D3DXMATRIX &wmat, D3DXVECTOR3 &t);
// Wn}gbNXvZ֐
extern void GrpSetRotTransMat(D3DXMATRIX &wmat, D3DXVECTOR3 &s, D3DXVECTOR3 &t, D3DXVECTOR3 &r);
// Cg̏Anm / nee؂ւ
extern void GrpSetLight(D3DLIGHT_MODE mode);
// tHO̐ݒ
extern void GrpSetFog(float st, float end, D3DCOLOR col);
// RcW@@QcWϊ
extern void GrpVecCnv2d(D3DXVECTOR3* out_vec, D3DXVECTOR3* cnv_vec, D3DXMATRIX* world);
// AWϊ_Zbg
extern inline void GrpTLVertexSet(D3DTLVERTEX *v, float x, float y, float z, float tu, float tv, D3DCOLOR rgba);
// AWϊL蒸_Zbg
extern inline void GrpLVertexSet(D3DLVERTEX *v, float x, float y, float z, float tu, float tv, D3DCOLOR rgba);
// LAWϊL蒸_Zbg
extern inline void GrpVertexSet(D3DVERTEX *v, float x, float y, float z, float nx, float ny, float nz, float tu, float tv);

////////////////////////////////////////////////////////////////////////////
//                             NX錾
////////////////////////////////////////////////////////////////////////////
// WnǗNX
class D3D_COORDINATE {
public:
	D3DXVECTOR3		scale;							// XP[
	D3DXVECTOR3		trans;							// ړxNg
	D3DXVECTOR3		rotate;							// ]xNg
	D3DXMATRIX		mat;							// Wn̕ϊ}gbNX
public:
	// RXgN^ixNg̏sj
	D3D_COORDINATE() {}
	D3D_COORDINATE(D3DXVECTOR3 s, D3DXVECTOR3 t, D3DXVECTOR3 r) {
		SetVect(s, t, r);
	}

	void SetVect(D3DXVECTOR3 s, D3DXVECTOR3 t, D3DXVECTOR3 r) {
		scale  = s;
		trans  = t;
		rotate = r;
		SetMat();
	}
	// XP[]ړϊς݃}gbNX쐬
	void SetMat(void) {
		// GrpSetRotTransMat́A^XP[xNgAړxNgA]xNg
		// mat = XP[mat  ~@ix]mat@~@w]mat@~@y]matj@~@ړmat@
		// Ƃϊ}gbNX𐶐܂
		// ܂AXP[ -> ] -> ړ ƌŏs}gbNX쐬܂B
		GrpSetRotTransMat(mat, scale, trans, rotate);
	}
};

#endif

